//------------------------------------------------------------------------------
// File:		playlist.h
// Description: playlist
//
// Copyright (C) 2006 JasonV
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//------------------------------------------------------------------------------



#ifndef __PLAYLIST_H__
#define __PLAYLIST_H__



// included files
//--------------------------------------------------
#include "types.h"



// Structs
//------------------------------------------------------------------------------
typedef struct _PlaylistEntry
{
	int index;										// index into the VideoFileList
} PlaylistEntry;



typedef struct _PlaylistInfo
{
	PlaylistEntry* play_list_entry;
	int number_of_entries;
	int list_size;
} PlaylistInfo;



typedef struct _POSInfo
{
	int resume_frame;
	int volume_boost;
	int zoom_mode;
	unsigned int* thumbnail;
} POSInfo;



// Function Declarations
//--------------------------------------------------
bool IsInPlaylist( int index );



#endif // __PLAYLIST_H__



